# Contributing to Casper Kotlin SDK
We appreciate all type of inputs. We want to make contributing to this project as easy and transparent as possible,  whether it's: 

- Reporting a bug
- Discussing the current state of the code
- Submitting a fix
- Proposing new features
- Becoming a maintainer

## We Develop with Github
We use github to host code,  to track issues and feature requests,  as well as accept pull requests.

## All Code Changes Happen Through Pull Requests
Pull requests are the best way to propose changes to the codebase. We actively welcome your pull requests: 

1. Fork the repo and create your branch from `master`.
2. If you've added code that should be tested,  add tests.
3. Ensure the test suite passes.
4. Make sure your code lints.
5. Issue that pull request!

## Report bugs using Github's issues
We use GitHub issues to track public bugs. Report a bug by opening a new issue.

## Any contributions you make will be under the MIT Software License
In short,  when you submit code changes,  your submissions are understood to be under the same [MIT License](http://choosealicense.com/licenses/mit/) that covers the project. Feel free to contact the maintainers if that's a concern.

## Sign your work

We use the Developer Certificate of Origin (DCO) as a additional safeguard
for the Casper Kotlin SDK project. This is a well established and widely used
mechanism to assure contributors have confirmed their right to license
their contribution under the project's license.
If you can certify it,  then just add a line to every git commit message: 

````
  Signed-off-by:  Random J Developer <random@developer.example.org>
````

Use your real name (sorry,  no pseudonyms or anonymous contributions).
If you set your `user.name` and `user.email` git configs,  you can sign your
commit automatically with `git commit -s`. You can also use git [aliases](https://git-scm.com/book/tr/v2/Git-Basics-Git-Aliases)
like `git config --global alias.ci 'commit -s'`. Now you can commit with
`git ci` and the commit will be signed.
